/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.portfolio.common;

/**
 * The Class Defines.
 * @version $Revision: 1.4 $, $Date: 2009/11/24 14:10:06 $
 */
public final class PortfolioDefines {

	/**
	 * Instantiates a new PortfolioDefines.
	 */
	private PortfolioDefines() {
		// Private constructor
	}

	/** The Constant SELECTED_ENTITIES. */
	public static final String SELECTED_ENTITIES = "selectedEntities";

	/** The Constant SELECTED_EVENTS. */
	public static final String SELECTED_EVENTS = "selectedEvents";

	/** The Constant SHOW_EVENTS. */
	public static final String SHOW_EVENTS = "showEvents";

	/** The Constant DATE_RANGE. */
	public static final String DATE_RANGE = "dateRange";

	/** The Constant EVIDENCE_LINKED_COMPETENCE. */
	public static final String EVIDENCE_LINKED_COMPETENCE = "EVIDENCE_LINKED_COMPETENCE";
	
	/** The Constant EVIDENCE_OBJECT. */
	public static final String EVIDENCE_OBJECT = "EVIDENCE_OBJECT";
}
