/*
 * Copyright (c) 2008, Consortium Board TENCompetence
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the TENCompetence nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY CONSORTIUM BOARD TENCOMPETENCE ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CONSORTIUM BOARD TENCOMPETENCE BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package apis;
import java.sql.*;
import java.util.Vector;
import nb_utils.*;
import java.io.*;
import java.net.URLDecoder;


/*
 *  UPF / Lau Llobet
 */


public class DAOAssessmentTest extends DAO{
    

    /** Creates a new instance of DAOUser */
    public DAOAssessmentTest() {
    }
    
    public boolean setTest (String id, UserTestCase user) throws SQLException
    {

        String command="";
        try{
        	setConnectionFromDAO(user.getConnectedDao());

        	ResultSet res;
        	command = "SELECT * FROM assessmenttest where test_id ='"+ id+"'";
           	res = stmt.executeQuery(command);
        	if(! res.next()){
        		command = "INSERT INTO assessmenttest(test_id) VALUES ('"+id+"')"; 
            	System.out.printf(command);
            	stmt.executeUpdate(command);
        	}
            return true;
        }catch(SQLException e)
        {
        	System.out.println("Error :"+command);
            e.printStackTrace();
            throw e;
        }/*finally{
        	 closeConnection();
        }*/
    }
    
    public int getTestKey(String id, UserTestCase user){
    	
      	try{
      		ResultSet res;
      		setConnectionFromDAO(user.getConnectedDao());
	    	String command = "SELECT test_key FROM assessmenttest where test_id ='"+ id+"'";
	       	res = stmt.executeQuery(command);
	       
	    	if(res.next()){
	    		return res.getInt("test_key");
	    	}
      	}catch(Exception e){
	    		e.printStackTrace();
	    		closeConnection();
	    }
      	return -1;
    }
    

    
}
