package apis;

import nb_utils.NBEasyXML;

import java.sql.SQLException;
import java.util.Vector;

public class QTIv22inline extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
 	QTIv2variableDeclaration var;
 	String optionList;
 	Vector formNames;
 	Vector partsGap ;
    protected boolean fixed;
    
    public QTIv22inline(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);    
        var = nvar;
        identifier = id;
        nm = getSafeFormID(var.identifier);
        Vector partsGap = new Vector(); // vector full of QTIv2_inlineChoice
        
    }
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {

    	int cidx = idx;//itemXML.findChildElement(idx);
    	//int depth = itemXML.getDepth(idx);
    	
    	 //while(cidx != -1 && (itemXML.getDepth(cidx) > depth))
        // { 

    	   int id = QTIv2define.identify(itemXML.getName(cidx));
       	 
    	  if( id ==  QTIv2define.QTIv2_inlineChoice ){
               if(partsGap == null)
            	   partsGap= new Vector();
               QTIv2inlineText gt = new QTIv2inlineText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
	           cidx = gt.parse(itemXML, cidx);
	           partsGap.add(gt);
	    /*       formNames.add(gt.nm+"_"+respCount);
	           respCount++;*/
          }
    //     }     
    	return super.parse( itemXML,  idx);
    }
    
    public String render()  throws InvalidQTIv2Exception //Vector partsGap comes frome the class itself since inline choice declares the list of options inside its code not like Helena's gapMatch 
    {
    	String out="";
         
   	    //generating option Lists
        for(int n=0; n < partsGap.size(); n++)
        {
      	   //name :apisa_RESPONSE (to change segons convingui)    value:Sp G1 ...
           out+="<option value=\""+ getSafeIdent(identifier)+"\">"
           	+((QTIv22inlineChoice)partsGap.get(n)).render()+ "</option>";
           
           DAOCloseAnswer daocloseanswer = new DAOCloseAnswer();
           try{
           	//[refactor]tmpdao.setResponseContext( getSafeIdent(identifier),context);
           	daocloseanswer.setCloseAnswer( getSafeIdent(identifier),((QTIv22inlineChoice)partsGap.get(n)).render(),this.theItem.theTest.getUser());
           }catch(SQLException e){
           	e.printStackTrace();
           } 
           
           
       }
       return out;
    }

    public boolean updateFromFormData()
    {
    	
		for (int n = 0; n < formNames.size(); n++)
	    {
	        String key = (String) formNames.get(n);
	    
	        if (theItem.formData.containsKey(key))
	            try
	            {
	                var.setValue((String) theItem.formData.get(key));
	            }
	            catch (InvalidQTIv2Exception ex)
	            {
	            }
	    }
		return false;
    }

}