package apis;

import nb_utils.NBEasyXML;

//Classe Abstracte
public abstract class QTIv22inlineChoice extends QTIv2structuredBodyPart 
{
    protected String nm;
    protected String identifier;
    QTIv2variableDeclaration var;
   
    protected QTIv22inlineChoice(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
    InvalidQTIv2Exception
    {
        super(owner);
        var = nvar;
        identifier = id;
        nm = getSafeFormID(var.identifier);
        
    }

    /** Note that subclasses must call this in their own parse methods. **/
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        //# read in attributes from the element
    	//matchMax= Integer.parseInt(itemXML.getAttribute(idx, "matchMax"));

    	return super.parse(itemXML, idx);
    } 
    
  	//renders list options 
    public String render()  throws InvalidQTIv2Exception
    {
    	 String out ="";
    	 //nm: apisa_RESPONSE value: W/Sp....(identifiers)
         out+=super.render();
    	 //out += "name='" + nm + "' value='" + getSafeIdent(identifier) + "'\">"+super.render();
         return out;
    }
}
class QTIv2inlineText extends QTIv22inlineChoice 
{
	  public QTIv2inlineText (QTIv2item owner, String id, QTIv2variableDeclaration nvar)throws
	    InvalidQTIv2Exception
	   {
	        super(owner, id, nvar);
		 }
	  	//renders list options 
	    public String render()  throws InvalidQTIv2Exception
	    {
	    	 String out = "";
	    	 //nm: apisa_RESPONSE value: W/Sp....(identifiers)
	         out+=super.render();
	    	 //out += "name='" + nm + "' value='" + getSafeIdent(identifier) + "'\">"+super.render();
	         return out;
	    }
}


