package apis;

import java.util.Vector;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import nb_utils.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2base
{
	/*
    private String rawXML; // not really needed, just there for development purposes
    NBEasyXML itemXML;

    public QTIv2base(String nItemXML)
    {
        rawXML = nItemXML;
        itemXML = new NBEasyXML(nItemXML);z
    }*/
	
    NBEasyXML testXML;
    String sTestXML;
    Vector responseVars, outcomeVars;
    
    public QTIv2base(String nTestXML)
    {
    	sTestXML=nTestXML;	
    	testXML = new NBEasyXML(nTestXML);
    }
     
   
    /**
     * parseVariableContents parses through the XML for default values, correct values and mappings used for
     * template scoring, and assigns them to the variable. (Possibly this should be a method of QTIv2Variable,
     * however I think this approach will avoid a lot of code duplication.)
     *
     * @param tmp QTIv2Variable is the variable that take the values that are parsed in.
     * @param position is the index of the current parse point in the NBEasyXML structure
     * @throws InvalidQTIv2Exception
     */	

}
