package apis;

import nb_utils.NBEasyXML;
import java.util.Vector;

public class QTIv2gap extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
 	QTIv2variableDeclaration var;
 	String optionList;
 	Vector formNames;
    protected boolean fixed;
    
    public QTIv2gap(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);   
        var = nvar;
        identifier = id;
        nm = getSafeFormID(var.identifier);
    }
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	
    	return super.parse( itemXML,  idx);
    }
    
    public String render(Vector partsGap)  throws InvalidQTIv2Exception
    {
    	String out="";
         
   	    //generating option Lists
        for(int n=0; n < partsGap.size(); n++)
        {
      	   //name :apisa_RESPONSE (to change segons convingui)    value:Sp G1 ...
           out+="<option value=\""+ ((QTIv2gapChoice)partsGap.get(n)).identifier +" "+ getSafeIdent(identifier)+"\">"
           	+((QTIv2gapChoice)partsGap.get(n)).render()+ "</option>";
           }
           out+="</select>";
       return out;
    }

    public boolean updateFromFormData()
    {
    	
		for (int n = 0; n < formNames.size(); n++)
	    {
	        String key = (String) formNames.get(n);
	    
	        if (theItem.formData.containsKey(key))
	            try
	            {
	                var.setValue((String) theItem.formData.get(key));
	            }
	            catch (InvalidQTIv2Exception ex)
	            {
	            }
	    }
		return false;
    }

}