package apis;

import nb_utils.NBEasyXML;


/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */


public class QTIv2simpleAssociableChoice extends QTIv2structuredBodyPart
{
   String nm;
    String identifier;
    int card;
    QTIv2variableDeclaration var;
    protected int matchMax;
    
    public QTIv2simpleAssociableChoice(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
    	   super(owner);
           var = nvar;
           card = var.cardinality;
           identifier = id;
           nm = getSafeFormID(var.identifier);
    }
    
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	   matchMax=Integer.parseInt(itemXML.getAttribute(idx,"matchMax"));
    	   
    	   return super.parse(itemXML, idx);
    }
    
   public String render() throws InvalidQTIv2Exception
    {
        String out = "<p>";
   
        out += super.render();
        out += "</p>";
        return out;
    }

}
