package apistesthost;

import javax.swing.UIManager;

/**
 * <p>
 * Title: APIS test wrapper
 * </p>
 * <p>
 * Description: A very very simple HTTP server
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class APIStestHost {
	boolean packFrame = false;

	// Construct the application
	public APIStestHost() {
		ATFrame frame = new ATFrame();
		// Validate frames that have preset sizes
		// Pack frames that have useful preferred size info, e.g. from their
		// layout
		if (packFrame) {
			frame.pack();
		} else {
			frame.validate();
		}
		frame.setVisible(true);
	}

	// Main method
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			// Runtime.exec("DB_run_me_first.bat");
		} catch (Exception e) {
			e.printStackTrace();
		}
		new APIStestHost();
	}
}
