package apistesthost;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Dimension;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.MouseEvent;
import java.awt.event.TextEvent;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToolBar;

public class ATFrame extends JFrame {
	static final long serialVersionUID = 8266471551516979662L; // ho exigia el
	// compilador,
	// nm X
	JPanel contentPane;
	JToolBar jToolBar = new JToolBar();
	JButton jButton3 = new JButton();
	JButton browserLaunchBtn = new JButton();
	JButton configLoadBtn = new JButton();
	JButton configSaveBtn = new JButton();
	ImageIcon image1;
	ImageIcon image2;
	ImageIcon image3;
	ImageIcon image4;
	JLabel statusBar = new JLabel();
	BorderLayout borderLayout1 = new BorderLayout();
	Checkbox debugModeChk = new Checkbox();
	Panel panel1 = new Panel();
	// XYLayout xYLayout1 = new XYLayout();
	Label label1 = new Label();
	Label label2 = new Label();
	Label label3 = new Label();
	Label label4 = new Label();

	TextField testDirEdt = new TextField();
	TextField itemDirEdt = new TextField();
	TextField mediaDirEdt = new TextField();
	TextField appletDirEdt = new TextField();

	Button testBrowse = new Button();
	Button itemBrowse = new Button();
	Button imgBrowse = new Button();
	Button appletBrowse = new Button();

	SimplisticHTTPd sh = new SimplisticHTTPd();
	String configNamePath = "";
	Thread t = new Thread(sh);

	// Construct the frame
	public ATFrame() {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
			functionalityInit();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	void startServer() {
		t.start();
	}

	// Component initialization
	private void jbInit() throws Exception {
		image1 = new ImageIcon(apistesthost.ATFrame.class.getResource("openFile.png"));
		image2 = new ImageIcon(apistesthost.ATFrame.class.getResource("closeFile.png"));
		image3 = new ImageIcon(apistesthost.ATFrame.class.getResource("help.png"));
		image4 = new ImageIcon(apistesthost.ATFrame.class.getResource("browse.png"));
		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(borderLayout1);
		this.setSize(new Dimension(365, 167));
		this.setTitle("APIS item host");
		this.addWindowListener(new ATFrame_this_windowAdapter(this));
		statusBar.setText(" ");
		configLoadBtn.setIcon(image1);
		configLoadBtn.setToolTipText("Load a configuration");
		configSaveBtn.setIcon(image2);
		configSaveBtn.addMouseListener(new ATFrame_configSaveBtn_mouseAdapter(this));
		configSaveBtn.setToolTipText("Save configuration");

		jButton3.setIcon(image3);
		jButton3.setToolTipText("Help");
		browserLaunchBtn.setIcon(image4);
		browserLaunchBtn.setToolTipText("Launch web browser");
		debugModeChk.setLabel("item debug mode");
		debugModeChk.addItemListener(new ATFrame_debugModeChk_itemAdapter(this));
		// panel1.setLayout(xYLayout1);
		statusBar.setText("");
		label1.setText("Test directory");
		label2.setText("Item directory");
		label3.setText("Media directory!");
		// label4.setText("Applet directory");

		testBrowse.setLabel("Browse");
		testBrowse.addActionListener(new ATFrame_testBrowse_actionAdapter(this));
		testBrowse.addMouseListener(new ATFrame_testBrowse_mouseAdapter(this));
		testDirEdt.setText("");
		testDirEdt.addTextListener(new ATFrame_testDirEdt_textAdapter(this));

		itemBrowse.setLabel("Browse");
		itemBrowse.addActionListener(new ATFrame_itemBrowse_actionAdapter(this));
		itemBrowse.addMouseListener(new ATFrame_itemBrowse_mouseAdapter(this));
		itemDirEdt.setText("");
		itemDirEdt.addTextListener(new ATFrame_itemDirEdt_textAdapter(this));

		imgBrowse.addMouseListener(new ATFrame_imgBrowse_mouseAdapter(this));
		imgBrowse.addActionListener(new ATFrame_imgBrowse_actionAdapter(this));
		imgBrowse.setLabel("Browse");
		imgBrowse.addMouseListener(new ATFrame_imgBrowse_mouseAdapter(this));
		mediaDirEdt.setText("");
		mediaDirEdt.addTextListener(new ATFrame_mediaDirEdt_textAdapter(this));

		/*
		 * appletBrowse.addMouseListener(new ATFrame_appletBrowse_mouseAdapter(this));
		 * appletBrowse.addActionListener(new ATFrame_appletBrowse_actionAdapter(this));
		 * appletBrowse.setLabel("Browse"); appletBrowse.addMouseListener(new ATFrame_appletBrowse_mouseAdapter(this));
		 * appletDirEdt.setText(""); appletDirEdt.addTextListener(new ATFrame_appletDirEdt_textAdapter(this));
		 */
		jToolBar.add(configLoadBtn);
		jToolBar.add(configSaveBtn);
		jToolBar.add(jButton3);
		jToolBar.add(browserLaunchBtn);
		contentPane.add(jToolBar, BorderLayout.NORTH);
		contentPane.add(statusBar, BorderLayout.SOUTH);
		contentPane.add(panel1, BorderLayout.CENTER);
		/*
		 * panel1.add(debugModeChk, new XYConstraints(2, 71, 152, 19)); panel1.add(testDirEdt, new XYConstraints(91, 2,
		 * 211, 19)); panel1.add(itemDirEdt, new XYConstraints(91, 26, 211, 19)); panel1.add(mediaDirEdt, new
		 * XYConstraints(91, 50, 211, 19)); // panel1.add(appletDirEdt, new XYConstraints(91, 75, 211, 19));
		 * 
		 * panel1.add(label1, new XYConstraints(5, 28, -1, -1)); panel1.add(label2, new XYConstraints(5, 6, -1, -1));
		 * panel1.add(label3, new XYConstraints(5, 50, -1, -1)); // panel1.add(label4, new XYConstraints(5, 75, -1,
		 * -1));
		 * 
		 * panel1.add(testBrowse, new XYConstraints(301, 1, 58, 21)); panel1.add(itemBrowse, new XYConstraints(301, 25,
		 * 58, 21)); panel1.add(imgBrowse, new XYConstraints(301, 49, 58, 21));
		 */
		// panel1.add(appletBrowse, new XYConstraints(301, 75, 58, 21));
	}

	private void functionalityInit() {

		startServer();
		while (sh.started == false)
			;
		String path = "http://127.0.0.1:" + String.valueOf(sh.getPort()) + "/";
		// launchBrowser(path);
		statusBar.setText("Server running on " + path);
		readConfigFile();
	}

	private boolean readConfigFile() {
		try {
			File f = new File("apistest.config");
			configNamePath = f.getAbsolutePath();
			if (f.exists() == false)
				return false;
			FileReader fr = new FileReader(f);
			BufferedReader br = new BufferedReader(fr);
			try {
				String in = br.readLine();
				while (in != null) {
					in.trim();
					if (!in.startsWith(";") && (in.indexOf("=") != -1)) {
						String nm = in.substring(0, in.indexOf("=")).trim();
						String vl = in.substring(in.indexOf("=") + 1).trim();
						if (nm.equals("testdir")) {
							testDirEdt.setText(vl);
							sh.testDir = vl;
						} else if (nm.equals("itemdir")) {
							itemDirEdt.setText(vl);
							sh.itemDir = vl;
						}

						else if (nm.equals("mediadir")) {

							mediaDirEdt.setText(vl);
							sh.mediaDir = vl;
						} else if (nm.equals("appletdir")) {
							appletDirEdt.setText(vl);
							sh.appletDir = vl;
						}
					}
					in = br.readLine();
				}
				br.close();
				fr.close();
			} catch (IOException ex1) {
			}
		} catch (FileNotFoundException ex) {
			return false;
		}
		return false;
	}

	private boolean writeConfigFile() {
		try {
			File f = new File(configNamePath);
			FileOutputStream os = new FileOutputStream(f);
			PrintWriter pr = new PrintWriter(os);
			if ((sh.testDir != null) && (sh.testDir.length() > 0))
				pr.println("testdir=" + sh.testDir);
			if ((sh.itemDir != null) && (sh.itemDir.length() > 0))
				pr.println("itemdir=" + sh.itemDir);

			if ((sh.mediaDir != null) && (sh.mediaDir.length() > 0))
				pr.println("mediadir=" + sh.mediaDir);
			if ((sh.appletDir != null) && (sh.appletDir.length() > 0))
				pr.println("appletdir=" + sh.appletDir);
			pr.close();
			try {
				os.close();
			} catch (IOException ex1) {
				return false;
			}
		} catch (FileNotFoundException ex) {
			return false;
		}
		return true;
	}

	// File | Exit action performed
	public void jMenuFileExit_actionPerformed(ActionEvent e) {
		System.exit(0);
	}

	protected void launchBrowser(String path) {
		String os = System.getProperty("os.name");
		if (os.startsWith("Windows")) {
			// this next line was copied from
			// /Reload/src/uk/ac/reload/dweezi/util/ReloadUtils.java - look
			// there for multi platform version
			// Runtime.getRuntime().exec(new String[] {"cmd.exe", "/c", "start",
			// "\"\"", '"' + path + '"'});
			try {
				Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + path);
			} catch (Exception e) {
				e.printStackTrace();

			}
		}

	}

	// Help | About action performed
	public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
	}

	// Overridden so we can exit when window is closed
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}

	/*
	 * void testBrowse_mouseClicked(MouseEvent e) { FileDialog dlg = new FileDialog(this,
	 * "Select a file in the item directory"); dlg.setVisible(true); testDirEdt.setText(dlg.getDirectory());
	 * 
	 * }
	 * 
	 * void testDirEdt_textValueChanged(TextEvent e) { sh.testDir = testDirEdt.getText(); }
	 * 
	 * void itemDirEdt_textValueChanged(TextEvent e) { sh.itemDir = itemDirEdt.getText(); }
	 * 
	 * void mediaDirEdt_textValueChanged(TextEvent e) { sh.mediaDir = mediaDirEdt.getText(); }
	 * 
	 * void appletDirEdt_textValueChanged(TextEvent e) { sh.appletDir = appletDirEdt.getText(); }
	 */
	void this_windowClosed(WindowEvent e) {
		// writeConfigFile();
	}

	void configSaveBtn_mouseClicked(MouseEvent e) {
		// writeConfigFile();

	}

	/*
	 * void imgBrouse_mouseClicked(MouseEvent e) { FileDialog dlg = new FileDialog(this,
	 * "Select a file in the media directory"); dlg.setVisible(true); mediaDirEdt.setText(dlg.getDirectory()); }
	 * 
	 * void appletBrowse_mouseClicked(MouseEvent e) { FileDialog dlg = new FileDialog(this,
	 * "Select a file in the APIS support applet directory"); dlg.setVisible(true);
	 * appletDirEdt.setText(dlg.getDirectory()); }
	 * 
	 * void debugModeChk_itemStateChanged(ItemEvent e) { if (debugModeChk.getState() == true) sh.debugMode = true; else
	 * sh.debugMode = false; }
	 */
}

class ATFrame_testBrowse_mouseAdapter extends java.awt.event.MouseAdapter {
	ATFrame adaptee;

	ATFrame_testBrowse_mouseAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		// adaptee.testBrowse_mouseClicked(e);
	}
}

class ATFrame_testBrowse_actionAdapter implements java.awt.event.ActionListener {
	ATFrame adaptee;

	ATFrame_testBrowse_actionAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
	}
}

class ATFrame_testDirEdt_textAdapter implements java.awt.event.TextListener {
	ATFrame adaptee;

	ATFrame_testDirEdt_textAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void textValueChanged(TextEvent e) {
		// adaptee.testDirEdt_textValueChanged(e);
	}
}

// ITEMS
class ATFrame_itemBrowse_actionAdapter implements java.awt.event.ActionListener {
	ATFrame adaptee;

	ATFrame_itemBrowse_actionAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
	}
}

class ATFrame_itemDirEdt_textAdapter implements java.awt.event.TextListener {
	ATFrame adaptee;

	ATFrame_itemDirEdt_textAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void textValueChanged(TextEvent e) {
		// adaptee.itemDirEdt_textValueChanged(e);
	}
}

// MEDIA
class ATFrame_mediaDirEdt_textAdapter implements java.awt.event.TextListener {
	ATFrame adaptee;

	ATFrame_mediaDirEdt_textAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void textValueChanged(TextEvent e) {
		// adaptee.mediaDirEdt_textValueChanged(e);
	}
}

class ATFrame_appletDirEdt_textAdapter implements java.awt.event.TextListener {
	ATFrame adaptee;

	ATFrame_appletDirEdt_textAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void textValueChanged(TextEvent e) {
		// adaptee.appletDirEdt_textValueChanged(e);
	}
}

class ATFrame_this_windowAdapter extends java.awt.event.WindowAdapter {
	ATFrame adaptee;

	ATFrame_this_windowAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void windowClosed(WindowEvent e) {
		adaptee.this_windowClosed(e);
	}
}

class ATFrame_configSaveBtn_mouseAdapter extends java.awt.event.MouseAdapter {
	ATFrame adaptee;

	ATFrame_configSaveBtn_mouseAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.configSaveBtn_mouseClicked(e);
	}
}

class ATFrame_imgBrowse_actionAdapter implements java.awt.event.ActionListener {
	ATFrame adaptee;

	ATFrame_imgBrowse_actionAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
	}
}

class ATFrame_appletBrowse_actionAdapter implements java.awt.event.ActionListener {
	ATFrame adaptee;

	ATFrame_appletBrowse_actionAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
	}
}

class ATFrame_imgBrowse_mouseAdapter extends java.awt.event.MouseAdapter {
	ATFrame adaptee;

	ATFrame_imgBrowse_mouseAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		// adaptee.imgBrouse_mouseClicked(e);
	}
}

class ATFrame_itemBrowse_mouseAdapter extends java.awt.event.MouseAdapter {
	ATFrame adaptee;

	ATFrame_itemBrowse_mouseAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		// adaptee.imgBrouse_mouseClicked(e);
	}
}

class ATFrame_appletBrowse_mouseAdapter extends java.awt.event.MouseAdapter {
	ATFrame adaptee;

	ATFrame_appletBrowse_mouseAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		// adaptee.appletBrowse_mouseClicked(e);
	}
}

class ATFrame_debugModeChk_itemAdapter implements java.awt.event.ItemListener {
	ATFrame adaptee;

	ATFrame_debugModeChk_itemAdapter(ATFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void itemStateChanged(ItemEvent e) {
		// adaptee.debugModeChk_itemStateChanged(e);
	}
}
