package apistesthost;

import java.io.BufferedReader;
import java.util.Enumeration;
import java.util.Hashtable;

public class HTTPRequestInfo {
	String tempInfo;
	String requestFile;
	int requestType;
	protected Hashtable requestParams, getVars;
	String extra_post_info;
	String post_info;

	void HTTPRequesInfo() {
		post_info = "";
	}

	public String fileName() {

		return requestFile;
	}

	public String getParam(String key) {
		return decodePercent((String) requestParams.get(key));
	}

	public int paramCount() {
		return requestParams.size();
	}

	Enumeration getKeys() {
		System.out.println("getKeys " + requestParams.keys().toString());
		return requestParams.keys();
	}

	boolean readInfo(BufferedReader brIn) {
		String line;
		String parseOne[], parseTwo[];

		tempInfo = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"><html><body>";
		requestParams = new Hashtable();
		getVars = new Hashtable();

		try {
			// first the request line, GET, POST etc + file and protocol
			line = brIn.readLine();
			parseOne = line.split("\\s+");

			if (parseOne[0] == "GET")
				requestType = 1;
			else if (parseOne[0] == "POST")
				requestType = 2;
			else
				requestType = 0;
			if (parseOne[1].indexOf("?") == -1)
				requestFile = parseOne[1];
			else {

				post_info = parseOne[1].substring(parseOne[1].indexOf("?") + 1);
				requestFile = parseOne[1].substring(0, parseOne[1].indexOf("?"));
				parseTwo = parseOne[1].substring(parseOne[1].indexOf("?") + 1).split("&");
				for (int n = 0; n < parseTwo.length; n++) {
					if (parseTwo[n].indexOf("=") != -1) {
						requestParams.put(parseTwo[n].substring(0, parseTwo[n].indexOf("=")), parseTwo[n]
								.substring(parseTwo[n].indexOf("=") + 1));
					}
				}
			}

			// # ignoring the protocol bit (parseOne[2]) for now.
			tempInfo += "<b>" + requestFile + "</b><br/>\n";

			// Lau ---- getting the form data

			// reading socket buffer
			char post_buff_ch[];
			post_buff_ch = new char[5000];
			brIn.read(post_buff_ch, 0, 5000);

			String post_buff = new String(post_buff_ch);

			// getting it's size
			String length_tag = "Content-Length: ";
			int length_property_index = post_buff.lastIndexOf(length_tag);
			int post_length;

			if (length_property_index == -1) {

				post_length = 0;
			} else
				post_length = (new Integer(post_buff.substring(length_property_index + length_tag.length(), post_buff
						.indexOf('\r', length_property_index)))).intValue();

			// separing header from content from void
			int separation_index = post_buff.indexOf("\r\n\r");
			String post_headers = post_buff.substring(0, separation_index);
			if (post_length != 0)
				extra_post_info = post_buff.substring(separation_index + 4, separation_index + post_length + 4);
			else
				extra_post_info = "";
			// Lau --- end

			// parsing the header and adding it to request parameters (as it
			String lines[] = post_headers.split("\n");
			for (int i = 0; i < lines.length; i++) {
				if (lines[i].indexOf(": ") != -1) {
					requestParams.put(lines[i].substring(0, lines[i].indexOf(": ")), lines[i].substring(lines[i]
							.indexOf(": ") + 2));
				}
				tempInfo += lines[i] + "<br/>\n";
			}
		} catch (Exception e) {
			System.err.println(e);
			e.printStackTrace();
			return false;
		}
		tempInfo += "</body></html>\n";
		return true;
	}

	String testInfo() {

		return tempInfo;
	}

	// copied from http://elonen.iki.fi/code/nanohttpd/NanoHTTPD.java.html, lack
	// of exception handling is my fault.
	/**
	 * Decodes the percent encoding scheme. <br/>
	 * For example: "an+example%20string" -> "an example string"
	 */
	private String decodePercent(String str) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			switch (c) {
			case '+':
				sb.append(' ');
				break;
			case '%':
				sb.append((char) Integer.parseInt(str.substring(i + 1, i + 3), 16));
				i += 2;
				break;
			default:
				sb.append(c);
				break;
			}
		}
		return new String(sb.toString().getBytes());
	}

}
