package apis;

import nb_utils.NBEasyXML;

/**
 * Class : variableMapping
 * 
 * Description
 * 
 * Attributes :	* sourceIdentifier 
 * 				* targetIdentifier 
 * */
public class QTIv21variableMapping {

	
	//-- Attributes specification
	protected String sourceIdentifier;		// sourceIdentifier [1]: identifier
	protected String targetIdentifier; 	 	// targetIdentifier [1]: identifier
	
	
	
	public QTIv21variableMapping ()
	{
		sourceIdentifier = " ";
		targetIdentifier = " ";
	}
	
	 public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
	 {
     //--  ATTRIBUTES
      
		// sourceIdentifier
		if(itemXML.getAttribute(idx,"sourceIdentifier")!= null)
        {
        	sourceIdentifier=itemXML.getAttribute(idx,"sourceIdentifier");
        }else 
        	throw new InvalidQTIv2Exception("sourceIdentifier needed for variableMapping");
        
		// sourceIdentifier
		if(itemXML.getAttribute(idx,"targetIdentifier")!= null)
        {
			targetIdentifier=itemXML.getAttribute(idx,"targetIdentifier");
        }else 
        	throw new InvalidQTIv2Exception("targetIdentifier needed for variableMapping");
        
		 return itemXML.findNextPeer(idx);
	 }
	
}
