package apis;

import nb_utils.*;
import java.io.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2XHTMLobject extends QTIv2bodyPart
{
    private int type;

    String content;

    public QTIv2XHTMLobject(QTIv2item owner, int element)
    {
        super(owner);
        type = element; // img or object
    }

    public int parse(NBEasyXML itemXML, int idx) throws apis.InvalidQTIv2Exception
    {
        if(type == QTIv2define.XHTML_img)
        {
            String src = itemXML.getAttribute(idx, "src");
            String src2 = "#mediaBase#" + src;
            content = itemXML.ExportBlock(idx);
            content = content.replaceFirst(src,src2);
            return itemXML.findEnd(idx)+1;
        }
        else
            content = "<p>XHTML object support not yet written.</p>";

        /**@todo Implement this apis.BodyPart abstract method*/
        throw new java.lang.UnsupportedOperationException("Method XHTMLobject.parse() not yet implemented.");
    }
    
    public int parseLikert(NBEasyXML itemXML, int idx) throws apis.InvalidQTIv2Exception
    {
        if(type == QTIv2define.XHTML_img)
        {
            String src = itemXML.getAttribute(idx, "src");
            String src2 = "#mediaBase#" + src;
            content = itemXML.ExportBlock(idx);
            content = content.replaceFirst(src,src2);
            return itemXML.findEnd(idx)+1;
        }
        else
            content = "<p>XHTML object support not yet written.</p>";

        /**@todo Implement this apis.BodyPart abstract method*/
        throw new java.lang.UnsupportedOperationException("Method XHTMLobject.parse() not yet implemented.");
    }

    public String render()
    {
        if (theItem.mediaBase != null)
            return content.replaceFirst("#mediaBase#", theItem.mediaBase);
        else
            return content.replaceFirst("#mediaBase#", "");
    }

}
