package apis.expression;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2variableDeclaration;

public class QTIv21Expr_numberResponded extends QTIv2expression {
	String sectionIdentifier;

	public QTIv21Expr_numberResponded(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		if (itemXML.getAttribute(idx, "sectionIdentifier") != null) {
			sectionIdentifier = itemXML.getAttribute(idx, "sectionIdentifier");
		} else
			sectionIdentifier = null;
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration c2 = theTest.getNumberResponded(sectionIdentifier);

		if (c2 == null)
			throw new InvalidQTIv2Exception("something horrible has gone wrong resolving variable " + sectionIdentifier);
		return ((QTIv2variableDeclaration) c2).getDuplicate();
	}

}