package apis;

import nb_utils.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class textEntryInteraction extends QTIv2stringInteraction
{
    public textEntryInteraction(QTIv2item owner)
    {
        super(owner);
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        return super.parse(itemXML, idx);
    }
    
    public int parseLikert(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        return super.parse(itemXML, idx);
    }

    public String render()
    {
        /**@todo Implement this apis.BodyPart abstract method*/
        String out = "<input type='text' name='" + getSafeFormID(responseIdentifier) + "' size='" + String.valueOf(expectedLength) +"'";
        String v = "";
        try
        {
            if (null != stringIdentifier)
            {
                v = stringVar.getStringValue(0);
            }
            else
            {
                v = responseVar.getStringValue(0);
            }
        }
        catch (InvalidQTIv2Exception ex)
        {
            v = null;
        }
        if (null != v)
            out += " value='" + v + "'";
        out += "/>";
        return out;
    }

}
