package apistesthost;

import java.io.File;
import java.util.Vector;

/**
 * <p>
 * Title: APIS test wrapper
 * </p>
 * <p>
 * Description: A very very simple HTTP server
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class FileList {
	private String dir;
	private Vector files;

	public FileList(String nDir) {
		dir = nDir;
		files = new Vector();
		File f = new File(dir);
		File fl[] = f.listFiles();
		for (int n = 0; n < fl.length; n++) {
			if ((fl[n].isFile()) && (fl[n].getName().endsWith(".xml")))
				files.add(fl[n].getName());
		}
	}

	public String getHTMLList() {
		String list;
		list = "<html><body><p>";
		for (int n = 0; n < files.size(); n++) {
			list += "<a href='render_test?file=" + files.get(n) + "'>" + files.get(n) + "</a><br/>\n";
		}
		list += "</p></body></html>";
		return list;
	}

}
